#include <catch2/catch_test_macros.hpp>
#include "map.hpp"
#include <fmt/core.h>

using namespace fmt;

TEST_CASE("dijkstra algo test", "[map]") {
  Matrix in_map = {
   {1, 1, 1, 0},
    {1, 0, 1, 1},
    {1, 0, 1, 1},
    {1, 1, 1, 1},
  };
  Matrix walls = {
    {0, 0, 0, 0},
    {0, 0, 0, 0},
    {0, 0, 1, 0},
    {0, 0, 1, 0},
  };
  Matrix expected = {
    {1, 1, 1, 0},
     {1, 0, 1, 1},
     {1, 0, 0, 2},
     {1, 1, 0, 3},
  };

  Matrix res = dijkstra_map(in_map, walls);

  println("--- EXPECTED:");
  dump_map(expected);
  println("--- RESULT:");
  dump_map(res);

  REQUIRE(res == expected);
}
